<script setup lang="ts">
import { useMemberStore } from '@/stores/member'
import type { Member } from '@/types/Member'
import { nextTick, onMounted, provide, ref, watch } from 'vue'
import { VForm } from 'vuetify/lib/components/index.mjs'

const memberStore = useMemberStore()

const headers = [
    {
        title: 'Id',
        key: 'id',
        value: 'id'
    },
    {
        title: 'FullName',
        key: 'name',
        value: 'name'
    },
    {
        title: 'Tel',
        key: 'tel',
        value: 'tel'
    },
    {
        title: 'Point',
        key: 'point',
        value: 'point'
    },
    { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initialMember: Member = {
    id: -1,
    name: '',
    tel: '',
    point: 0
}

provide('ini', initialMember)

const editedMember = ref<Member>(JSON.parse(JSON.stringify(initialMember)))
const membership = memberStore.members
let editedIndex = -1
let lastId = memberStore.members.length + 1
function onSubmit() { }
function closeDelete() {
    dialogDelete.value = false
    nextTick(() => {
        editedMember.value = Object.assign({}, initialMember)
    })
}
function deleteItemConfirm() {
    //Delete item from list
    membership.splice(editedIndex, 1)
    closeDelete()
}
function editItem(item: Member) {
    editedIndex = membership.indexOf(item)
    editedMember.value = Object.assign({}, item)
    dialog.value = true
}
function deleteItem(item: Member) {
    editedIndex = membership.indexOf(item)
    editedMember.value = Object.assign({}, item)
    dialogDelete.value = true
    editedIndex = -1
}
function closeDialog() {
    dialog.value = false
    nextTick(() => {
        editedMember.value = Object.assign({}, initialMember)
        editedIndex = -1
    })
}
async function save() {
    const { valid } = await refForm.value!.validate()

    if (!valid) return

    if (editedIndex > -1) {
        Object.assign(membership[editedIndex], editedMember.value)
    } else {
        editedMember.value.id = lastId++
        memberStore.saveMember(editedMember.value)
    }

    closeDialog()
}
function initialize() {
    membership.values = memberStore.members.values
}

onMounted(() => {
    initialize()
})

const FakeAPI = {
    async fetch({
        page,
        itemsPerPage,
        sortBy,
        search
    }: {
        page: number
        itemsPerPage: number
        sortBy: { key: string; order: string }[]
        search: { tel?: string }
    }) {
        return new Promise((resolve) => {
            setTimeout(() => {
                const start = (page - 1) * itemsPerPage
                const end = start + itemsPerPage
                const items = membership.slice().filter((item) => {
                    if (search.tel && !item.tel.toLowerCase().includes(search.tel.toLowerCase())) {
                        return false
                    }
                    return true
                })

                if (sortBy.length) {
                    const sortKey = sortBy[0].key
                    const sortOrder = sortBy[0].order
                    items.sort((a, b) => {
                        const aValue = a[sortKey]
                        const bValue = b[sortKey]
                        return sortOrder === 'desc' ? bValue - aValue : aValue - bValue
                    })
                }

                const paginated = items.slice(start, end)

                resolve({ items: paginated, total: items.length })
            }, 500)
        })
    }
}

const itemsPerPage = ref(5)
const serverItems = ref([])
const loading2 = ref(true)
const totalItems = ref(0)
const tel = ref('')
const search = ref('')

watch([tel], () => {
    search.value = String(Date.now())
})

const loadItems = ({
    page,
    itemsPerPage,
    sortBy
}: {
    page: number
    itemsPerPage: number
    sortBy: { key: string; order: string }[]
}) => {
    loading.value = true
    initialize()
    FakeAPI.fetch({
        page,
        itemsPerPage,
        sortBy,
        search: { tel: tel.value }
    }).then(({ items, total }) => {
        membership.values = items
        totalItems.value = total
        loading.value = false
    })
    initialize()
}
</script>

<template>
    <div style="background-color: rgba(82, 72, 54, 0.829);">
        <v-toolbar-title style="font-size: 20pt; margin-left: 20px; padding-top: 20px; color: rgb(255, 255, 255)">
            Member</v-toolbar-title><br />
        <v-row>
            <v-col>
                <tr>
                    <td>
                        <v-text-field v-model="tel" hide-details placeholder="Search Tel" class="ma-2" density="compact"
                            style="width: 300px" variant="solo-inverted"></v-text-field>
                    </td>
                    <v-btn style="margin-top: -30px; margin-left: 20px" color="primary" @click="initialize"><v-icon>mdi
                            mdi-restart</v-icon></v-btn>
                </tr>
            </v-col>
            <v-col cols="3" style="margin-top: 10px">
                <v-dialog v-model="dialog" persistent width="1024">
                    <template v-slot:activator="{ props }">
                        <v-btn color="white" v-bind="props" variant="outlined" style="margin-top: 2px; margin-left: 100px"><v-icon style="margin-right: 8px;">mdi-account-plus</v-icon> Add Member
                        </v-btn>
                    </template>
                    <v-card>
                        <v-card-title>
                            <span class="text-h5">Member Info</span>
                        </v-card-title>
                        <v-card-text>
                            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                                <v-container>
                                    <v-row>
                                        <v-col cols="12" sm="12" md="4">
                                            <v-text-field v-model="editedMember.name" :readonly="loading"
                                                :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                label="Name"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="12" md="4">
                                            <v-text-field v-model="editedMember.tel" :readonly="loading"
                                                :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                label="Tel"></v-text-field>
                                        </v-col>
                                    </v-row>
                                </v-container>
                            </v-form>
                            <small>*indicates required field</small>
                        </v-card-text>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                            <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
                <!-- Delete Dialog -->
                <v-dialog v-model="dialogDelete" max-width="500px">
                    <v-card>
                        <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                            <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                            <v-spacer></v-spacer>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-col>
        </v-row>
    </div>
    <div>
        <v-data-table-server v-model:items-per-page="itemsPerPage" :search="search" :headers="headers"
            :items-length="totalItems" :items="memberStore.members" :loading="loading" item-value="name"
            @update:options="loadItems" class="custom-table-style">
            <template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
                <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
            </template>
            <template v-slot:no-data>
                <v-btn color="primary" @click="initialize">Reset</v-btn>
            </template>
        </v-data-table-server>
    </div>
</template>
<style scoped>
.custom-table-style {
    background-color: rgba(202, 174, 123, 0.582);
    border-radius: 10px;
    margin-top: 25px;
}

.custom-edit-icon {
    color: #000000;
}

.custom-delete-icon {
    color: #000000;
}
</style>